unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, Menus, about, global, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    F1: TMenuItem;
    ImageList1: TImageList;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    StatusBar1: TStatusBar;
    V1: TMenuItem;
    H1: TMenuItem;
    OpenMenu: TMenuItem;
    SaveMenu: TMenuItem;
    SaveAsMenu: TMenuItem;
    SaveTgaMenu: TMenuItem;
    CloseFileMenu: TMenuItem;
    N2: TMenuItem;
    ExportPaletteMenu: TMenuItem;
    ImportPaletteMenu: TMenuItem;
    N4: TMenuItem;
    X1: TMenuItem;
    DarkBgMenu: TMenuItem;
    WpalMenu: TMenuItem;
    BlogE1: TMenuItem;
    WasSee20A1: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    SaveDialog1: TSaveDialog;
    procedure WasSee20A1Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DarkBgMenuClick(Sender: TObject);
    procedure OpenMenuClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SaveMenuClick(Sender: TObject);
    procedure SaveAsMenuClick(Sender: TObject);
    procedure CloseFileMenuClick(Sender: TObject);
    procedure SaveTgaMenuClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure WpalMenuClick(Sender: TObject);
    procedure BlogE1Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ShellAPI, pal;

{$R *.dfm}

procedure TForm1.WasSee20A1Click(Sender: TObject);
begin
  AboutForm.ShowModal();
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
  WasSee20A1.Click();
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  refbmp: TBitmap; // reference of bgbmp
  x,y: Integer;
begin
  refbmp := WasSeeGlobal.GetBgBmp;

  x := (Self.ClientWidth - refbmp.Width) div 2;
  y := (Self.ClientHeight - refbmp.Height + CoolBar1.Height - StatusBar1.Height) div 2;

  Self.Canvas.Draw(x, y, refbmp);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  WasSeeGlobal.UpdateUI;
  WasSeeGlobal.UpdateBgBmp;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  // ״̬
  StatusBar1.Panels.Items[0].Width := Self.ClientWidth - 200;

  Self.Refresh;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.DoubleBuffered := True;
end;

procedure TForm1.DarkBgMenuClick(Sender: TObject);
begin
  WasSeeGlobal.SwitchDarkBg;
end;

procedure TForm1.OpenMenuClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    WasSeeGlobal.OpenWasFile(OpenDialog1.FileName);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  WasSeeGlobal.FrameNext;
end;

procedure TForm1.SaveMenuClick(Sender: TObject);
begin
  WasSeeGlobal.SaveWasFile;
end;

procedure TForm1.SaveAsMenuClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    WasSeeGlobal.SaveWasToFile(SaveDialog1.FileName);
  end;
end;

procedure TForm1.CloseFileMenuClick(Sender: TObject);
begin
  WasSeeGlobal.CloseWasFile;
end;

procedure TForm1.SaveTgaMenuClick(Sender: TObject);
begin
  WasSeeGlobal.SaveTgaGroup;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  OpenMenu.Click;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  SaveAsMenu.Click;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  WpalMenu.Click;
end;

procedure TForm1.X1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.WpalMenuClick(Sender: TObject);
begin
  PalForm.ShowModal;
end;

procedure TForm1.BlogE1Click(Sender: TObject);
var
  myurl: string;
begin
  myurl := 'http://blog.csdn.net/leexuany/';
  ShellExecute(Handle, nil, PChar(myurl), nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.N6Click(Sender: TObject);
var
  myurl: string;
begin
  myurl := 'http://xyq.netease.com/viewthread.php?tid=814478';
  ShellExecute(Handle, nil, PChar(myurl), nil, nil, SW_SHOWNORMAL);
end;

end.
