unit WDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, FileCtrl;

type
  TWpalDialog = class(TForm)
    Ok_Button: TButton;
    Cancel_Button: TButton;
    TabControl1: TTabControl;
    Label1: TLabel;
    FileListBox1: TFileListBox;
    procedure Ok_ButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Cancel_ButtonClick(Sender: TObject);
  private
    { Private declarations }
    FFileName: TFileName;
    FWpalPath: array [0..1] of string;
  public
    { Public declarations }
    function Execute(): Boolean;
    function GetFileName(): TFileName;
  end;

var
  WpalDialog: TWpalDialog;

implementation

{$R *.dfm}

function TWpalDialog.GetFileName(): TFileName;
begin
  Result := FFileName;
end;

function TWpalDialog.Execute(): Boolean;
begin
  if Self.ShowModal = mrOK then
    Result := True
  else
    Result := False;
end;

procedure TWpalDialog.Ok_ButtonClick(Sender: TObject);
begin
  if FFileName = '' then
    ShowMessage('ѡҪļ')
  else
    Self.ModalResult := mrOK;
end;

procedure TWpalDialog.FormCreate(Sender: TObject);
var
  str: string;
begin
//  str := 'D:\WasSee\WasSee2.0\upload\';
  str := ExtractFilePath(Application.ExeName);
  FWpalPath[0] := str + 'λõɫ';
  FWpalPath[1] := str + '󻰵ɫ';
  FFileName := '';
  Label1.Caption := '';
end;

procedure TWpalDialog.FileListBox1Change(Sender: TObject);
var
  i: Integer;
begin
  i := FileListBox1.ItemIndex;
  if i>-1 then
  begin
    Label1.Caption := FileListBox1.Items.Strings[i];
    FFileName := FileListBox1.FileName;
  end;
end;

procedure TWpalDialog.TabControl1Change(Sender: TObject);
var
  i: Integer;
begin
  i := TabControl1.TabIndex;
  if i<0 then
    FileListBox1.Clear
  else
    FileListBox1.Directory := FWpalPath[i];
end;

procedure TWpalDialog.FormShow(Sender: TObject);
begin
  TabControl1Change(Sender);
end;

procedure TWpalDialog.Cancel_ButtonClick(Sender: TObject);
begin
  Self.ModalResult := mrCancel;
end;

end.
