unit global;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Dialogs, was;

type
  TMyGlobal = class
  private
    IsFileOpen: Boolean; // ļǷ
    IsDarkBG: Boolean;   // Ƿʹɫ
    bgbmp: TBitmap;      // 640 X 480 for WM_PAINT
    wasfile: TWasFile;
    FrameNum: Integer;
    WasKeyS: array [0..7] of TPoint;
    procedure ClearBgBmp;
  public
    constructor Create;
    destructor Destroy; override;
    procedure UpdateUI;
    function GetBgBmp: TBitmap;
    procedure UpdateBgBmp;
    procedure SwitchDarkBg;
    procedure SaveWasFile;
    procedure SaveWasToFile(const FileName: string);
    procedure OpenWasFile(const FileName: string);
    procedure CloseWasFile;
    procedure FrameNext;
    procedure SaveTgaGroup;
    procedure GetCurrentPal(var aHighPal: HighPal);
    procedure GetOriginalPal(var aHighPal: HighPal);
    procedure SetCurrentPal(aHighPal: HighPal);
  end;

var
  WasSeeGlobal: TMyGlobal;

implementation

uses MainForm;

constructor TMyGlobal.Create;
begin
  // init for bool variable
  IsFileOpen := False;
  IsDarkBG := False;
  // init for WasKeyS
  WasKeyS[0].X := 320;
  WasKeyS[0].Y := 96;
  WasKeyS[1].X := 448;
  WasKeyS[1].Y := 96;
  WasKeyS[2].X := 320;
  WasKeyS[2].Y := 224;
  WasKeyS[3].X := 448;
  WasKeyS[3].Y := 224;
  WasKeyS[4].X := 64;
  WasKeyS[4].Y := 352;
  WasKeyS[5].X := 192;
  WasKeyS[5].Y := 352;
  WasKeyS[6].X := 320;
  WasKeyS[6].Y := 352;
  WasKeyS[7].X := 448;
  WasKeyS[7].Y := 352;
  // init for bgbmp
  bgbmp := TBitmap.Create;
  bgbmp.PixelFormat := pf24bit;
  bgbmp.Width := 640;
  bgbmp.Height := 480;
  // init for wasfile
  wasfile := TWasFile.Create;
  FrameNum := -1;

  // Update BgBmp
  Self.UpdateBgBmp;
end;

destructor TMyGlobal.Destroy;
begin
  if bgbmp <> nil then
    bgbmp.Free;
  if wasfile <> nil then
    wasfile.Free;
end;

procedure TMyGlobal.UpdateUI;
begin
  with Form1 do
  begin
    // For File Menu
    SaveMenu.Enabled := IsFileOpen;
    SaveAsMenu.Enabled := IsFileOpen;
    SaveTgaMenu.Enabled := IsFileOpen;
    ExportPaletteMenu.Enabled := False; // IsFileOpen;
    ImportPaletteMenu.Enabled := False; // IsFileOpen;
    CloseFileMenu.Enabled := IsFileOpen;
    // For View Menu
    DarkBgMenu.Checked := IsDarkBG;
    WpalMenu.Enabled := IsFileOpen;
    // For Toolbar Item
    ToolButton2.Enabled := IsFileOpen;
    ToolButton4.Enabled := IsFileOpen;
    // For Timer1
    Timer1.Enabled := IsFileOpen;
  end;
end;

function TMyGlobal.GetBgBmp: TBitmap;
begin
  Result := bgbmp;
end;

procedure TMyGlobal.ClearBgBmp;
var
  tilebmp: TBitmap;
  i,j: Integer;
begin
  tilebmp := TBitmap.Create;
  tilebmp.PixelFormat := pf24bit;
  tilebmp.Width := 32;
  tilebmp.Height := 32;

  if IsDarkBG then
  begin // ʹɫ tilebmp
    tilebmp.Canvas.Brush.Color := RGB( 16,  16,  66);
    tilebmp.Canvas.FillRect(Rect( 0,  0, 16, 16));
    tilebmp.Canvas.FillRect(Rect(16, 16, 32, 32));
    tilebmp.Canvas.Brush.Color := RGB( 33,  48,  66);
    tilebmp.Canvas.FillRect(Rect( 0, 16, 16, 32));
    tilebmp.Canvas.FillRect(Rect(16,  0, 32, 16));
  end
  else
  begin // ʹǳɫ tilebmp
    tilebmp.Canvas.Brush.Color := RGB(198, 195, 247);
    tilebmp.Canvas.FillRect(Rect( 0,  0, 16, 16));
    tilebmp.Canvas.FillRect(Rect(16, 16, 32, 32));
    tilebmp.Canvas.Brush.Color := RGB(247, 243, 247);
    tilebmp.Canvas.FillRect(Rect( 0, 16, 16, 32));
    tilebmp.Canvas.FillRect(Rect(16,  0, 32, 16));
  end;

  // start clear
  for i:=0 to (bgbmp.Height div 32) do
    for j:=0 to (bgbmp.Width div 32) do
      bgbmp.Canvas.Draw(32 * j, 32 * i, tilebmp);
  // end clear

  tilebmp.Free;
end;

procedure TMyGlobal.SwitchDarkBg;
begin
  IsDarkBG := not IsDarkBG;
  Self.UpdateBgBmp;
  Form1.DarkBgMenu.Checked := IsDarkBG;
  form1.Refresh;
end;

procedure TMyGlobal.UpdateBgBmp;
var
  SCount, FCount: Integer;
  i, x, y: Integer;
begin
  Self.ClearBgBmp;
  // draw blue lines
  bgbmp.Canvas.Pen.Color := RGB(0, 0, 255);
  bgbmp.Canvas.MoveTo(0, 0);
  bgbmp.Canvas.LineTo(255, 0);
  bgbmp.Canvas.LineTo(255, 255);
  bgbmp.Canvas.LineTo(0, 255);
  bgbmp.Canvas.LineTo(0, 0);

  if wasfile.GetIsInit then
  begin
    SCount := wasfile.GetSpriteCount;
    FCount := wasfile.GetFrameCount;
    if SCount > 8 then
      SCount := 8;
    Dec(SCount);
    // draw first view
    wasfile.DrawByKey(bgbmp, 130, 161, 0);
    bgbmp.Canvas.Pen.Color := RGB(0, 255, 0);
    bgbmp.Canvas.MoveTo(125, 161);
    bgbmp.Canvas.LineTo(135, 161);
    bgbmp.Canvas.MoveTo(130, 156);
    bgbmp.Canvas.LineTo(130, 166);
    // draw sprite 1-8
    FrameNum := FrameNum mod FCount;
    bgbmp.Canvas.Pen.Color := RGB(255, 0, 0);
    for i:=0 to SCount do
    begin
      // ȷҪĸ
      x := WasKeyS[i].X;
      y := WasKeyS[i].Y;
      bgbmp.Canvas.MoveTo(x-32, y-16);
      bgbmp.Canvas.LineTo(x+32, y+16);
      bgbmp.Canvas.MoveTo(x+32, y-16);
      bgbmp.Canvas.LineTo(x-32, y+16);
      wasfile.DrawByKey(bgbmp, x, y, i*FCount+FrameNum);
    end;
  end;
end;

procedure TMyGlobal.OpenWasFile(const FileName: string);
begin
  if wasfile.GetIsInit then
  begin
    if wasfile.GetFileName = FileName then
    begin // ļѴ򿪣ô Exit
      Exit;
    end;
  end;

  try
    wasfile.LoadFromFile(FileName);
    FrameNum := 0;
  finally
    //
    IsFileOpen := wasfile.GetIsInit;

    if IsFileOpen then
    begin
      Form1.StatusBar1.Panels.Items[0].Text := FileName;
      Form1.StatusBar1.Panels.Items[1].Text := ': ' + IntToStr(wasfile.GetSpriteCount);
      Form1.StatusBar1.Panels.Items[2].Text := '֡: ' +IntToStr(wasfile.GetFrameCount);
    end
    else
    begin
      Form1.StatusBar1.Panels.Items[0].Text := '';
      Form1.StatusBar1.Panels.Items[1].Text := ': 0';
      Form1.StatusBar1.Panels.Items[2].Text := '֡: 0';
    end;

    Self.UpdateBgBmp;
    Self.UpdateUI;
    Form1.Refresh;
  end;
end;

procedure TMyGlobal.SaveWasFile;
begin
  if wasfile.GetIsInit then
  begin
    wasfile.SaveToFile(wasfile.GetFileName);
  end;
end;

procedure TMyGlobal.SaveWasToFile(const FileName: string);
begin
  if wasfile.GetIsInit then
  begin
    if FileExists(FileName) then
    begin
      if MessageBox(0, PChar('ļ'+FileName+'Ѵ'+#13+'Ƿ񸲸ǣ'), 'ʾ',
       MB_ICONQUESTION+MB_OKCANCEL) = mrCancel then
      begin
        Exit;
      end;
    end;
    wasfile.SaveToFile(FileName);
    ShowMessage('ϣ');
  end;
end;

procedure TMyGlobal.FrameNext;
begin
  if wasfile.GetIsInit then
  begin
    Inc(FrameNum);
    FrameNum := FrameNum mod wasfile.GetFrameCount;
    Self.UpdateBgBmp;
    Form1.Refresh;
  end;
end;

procedure TMyGlobal.CloseWasFile;
begin
  if wasfile.GetIsInit then
  begin
    IsFileOpen := False;
    wasfile.Close;

    Form1.StatusBar1.Panels.Items[0].Text := '';
    Form1.StatusBar1.Panels.Items[1].Text := ': 0';
    Form1.StatusBar1.Panels.Items[2].Text := '֡: 0';

    Self.UpdateUI;
    Self.UpdateBgBmp;
    Form1.Refresh;
  end;
end;

procedure TMyGlobal.GetCurrentPal(var aHighPal: HighPal);
begin
  wasfile.GetCurrentPal(aHighPal);
end;

procedure TMyGlobal.GetOriginalPal(var aHighPal: HighPal);
begin
  wasfile.GetOriginalPal(aHighPal);
end;

procedure TMyGlobal.SetCurrentPal(aHighPal: HighPal);
begin
  wasfile.SetCurrentPal(aHighPal);
end;

procedure TMyGlobal.SaveTgaGroup;
begin
  if wasfile.GetIsInit then
  begin
    wasfile.SaveToTGA;
    ShowMessage('TGAͼƬ鵼ϣ');
  end;
end;

initialization
  WasSeeGlobal := TMyGlobal.Create;

finalization
  WasSeeGlobal.Free;  

end.
