unit pal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, was, global;

type
  TPalArg = record
    C11: Cardinal;
    C12: Cardinal;
    C13: Cardinal;
    C21: Cardinal;
    C22: Cardinal;
    C23: Cardinal;
    C31: Cardinal;
    C32: Cardinal;
    C33: Cardinal;
  end;

  PalInfo = record
    Start: Integer;
    Finish: Integer;
    pp: TPalArg;
  end;

  PalLib = record
    Start: Integer;
    Finish: Integer;
    pp: array of TPalArg;
  end;

  TPalForm = class(TForm)
    RadioGroup1: TRadioGroup;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    TrackBar9: TTrackBar;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    RadioGroup5: TRadioGroup;
    Button5: TButton;
    Button6: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit5KeyPress(Sender: TObject; var Key: Char);
    procedure Edit6KeyPress(Sender: TObject; var Key: Char);
    procedure Edit7KeyPress(Sender: TObject; var Key: Char);
    procedure Edit8KeyPress(Sender: TObject; var Key: Char);
    procedure Edit9KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure RadioGroup2Click(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure RadioGroup4Click(Sender: TObject);
    procedure RadioGroup5Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
    procedure TrackBar8Change(Sender: TObject);
    procedure TrackBar9Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    oldpal: HighPal;
    OriginalPal: HighPal;
    CurrentPal: HighPal;
    IsBack: Boolean;  // Ƿԭɫ
    PPLib: array of PalLib;
    tmpPal: array of PalInfo;
    procedure ChangePalette(Start, Finish: Integer; ArgS: TPalArg);
  public
    { Public declarations }
    procedure ClearPalLib;
  end;

var
  PalForm: TPalForm;
  function GetNumberFromStream(Stream: TStream): Integer;

implementation

uses input, WDialog;

{$R *.dfm}

function GetNumberFromStream(Stream: TStream): Integer;
var
  i: Integer;
begin
  Stream.Read(i, 4);
  Result := i;
end;

procedure TPalForm.ClearPalLib;
var
  i: Integer;
begin
  for i:=Low(PPLib) to High(PPLib) do
  begin
    PPLib[i].pp := nil;
  end;
  PPLib := nil;
  PalForm.RadioGroup2.Items.Clear;
  PalForm.RadioGroup3.Items.Clear;
  PalForm.RadioGroup4.Items.Clear;
  PalForm.RadioGroup5.Items.Clear;
end;

procedure TPalForm.Button4Click(Sender: TObject);
begin
  if Button4.Caption = '<<' then
  begin
    PalForm.Width := 381;
    Button4.Caption := '>>';
  end
  else
  begin
    PalForm.Width := 927;
    Button4.Caption := '<<';
  end;
end;

procedure TPalForm.Button6Click(Sender: TObject);
begin
  InputForm.ShowModal;
end;

procedure TPalForm.RadioGroup1Click(Sender: TObject);
var
  i: Integer;
begin
  i := RadioGroup1.ItemIndex;
  TrackBar1.Position := tmpPal[i].pp.C11;
  TrackBar2.Position := tmpPal[i].pp.C12;
  TrackBar3.Position := tmpPal[i].pp.C13;
  TrackBar4.Position := tmpPal[i].pp.C21;
  TrackBar5.Position := tmpPal[i].pp.C22;
  TrackBar6.Position := tmpPal[i].pp.C23;
  TrackBar7.Position := tmpPal[i].pp.C31;
  TrackBar8.Position := tmpPal[i].pp.C32;
  TrackBar9.Position := tmpPal[i].pp.C33;
  Edit1.Text := IntToStr(tmpPal[i].pp.C11);
  Edit2.Text := IntToStr(tmpPal[i].pp.C12);
  Edit3.Text := IntToStr(tmpPal[i].pp.C13);
  Edit4.Text := IntToStr(tmpPal[i].pp.C21);
  Edit5.Text := IntToStr(tmpPal[i].pp.C22);
  Edit6.Text := IntToStr(tmpPal[i].pp.C23);
  Edit7.Text := IntToStr(tmpPal[i].pp.C31);
  Edit8.Text := IntToStr(tmpPal[i].pp.C32);
  Edit9.Text := IntToStr(tmpPal[i].pp.C33);
end;

procedure TPalForm.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TPalForm.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit1.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar1.Position:=i;
  end;
end;

procedure TPalForm.Edit2KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit2.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar2.Position:=i;
  end;
end;

procedure TPalForm.Edit3KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit3.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar3.Position:=i;
  end;
end;

procedure TPalForm.Edit5KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit5.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar5.Position:=i;
  end;
end;

procedure TPalForm.Edit6KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit6.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar6.Position:=i;
  end;
end;

procedure TPalForm.Edit7KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit7.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar7.Position:=i;
  end;
end;

procedure TPalForm.Edit8KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit8.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar8.Position:=i;
  end;
end;

procedure TPalForm.Edit9KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit9.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar9.Position:=i;
  end;
end;

procedure TPalForm.Edit4KeyPress(Sender: TObject; var Key: Char);
var
  i: Integer;
begin
  if Key = #13 then
  begin
    i := StrToInt(Edit4.Text);
    if i<0 then
    begin
      i := 0;
    end;
    if i>512 then
    begin
      i := 512;
    end;
    TrackBar4.Position:=i;
  end;
end;

procedure TPalForm.RadioGroup2Click(Sender: TObject);
var
  i: Integer;
begin
  i := RadioGroup2.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  RadioGroup1.ItemIndex := 0;
  TrackBar1.Position := PPLib[0].pp[i].C11;
  TrackBar2.Position := PPLib[0].pp[i].C12;
  TrackBar3.Position := PPLib[0].pp[i].C13;
  TrackBar4.Position := PPLib[0].pp[i].C21;
  TrackBar5.Position := PPLib[0].pp[i].C22;
  TrackBar6.Position := PPLib[0].pp[i].C23;
  TrackBar7.Position := PPLib[0].pp[i].C31;
  TrackBar8.Position := PPLib[0].pp[i].C32;
  TrackBar9.Position := PPLib[0].pp[i].C33;
end;

procedure TPalForm.RadioGroup3Click(Sender: TObject);
var
  i: Integer;
begin
  i := RadioGroup3.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  RadioGroup1.ItemIndex := 1;
  TrackBar1.Position := PPLib[1].pp[i].C11;
  TrackBar2.Position := PPLib[1].pp[i].C12;
  TrackBar3.Position := PPLib[1].pp[i].C13;
  TrackBar4.Position := PPLib[1].pp[i].C21;
  TrackBar5.Position := PPLib[1].pp[i].C22;
  TrackBar6.Position := PPLib[1].pp[i].C23;
  TrackBar7.Position := PPLib[1].pp[i].C31;
  TrackBar8.Position := PPLib[1].pp[i].C32;
  TrackBar9.Position := PPLib[1].pp[i].C33;
end;

procedure TPalForm.RadioGroup4Click(Sender: TObject);
var
  i: Integer;
begin
  i := RadioGroup4.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  RadioGroup1.ItemIndex := 2;
  TrackBar1.Position := PPLib[2].pp[i].C11;
  TrackBar2.Position := PPLib[2].pp[i].C12;
  TrackBar3.Position := PPLib[2].pp[i].C13;
  TrackBar4.Position := PPLib[2].pp[i].C21;
  TrackBar5.Position := PPLib[2].pp[i].C22;
  TrackBar6.Position := PPLib[2].pp[i].C23;
  TrackBar7.Position := PPLib[2].pp[i].C31;
  TrackBar8.Position := PPLib[2].pp[i].C32;
  TrackBar9.Position := PPLib[2].pp[i].C33;
end;

procedure TPalForm.RadioGroup5Click(Sender: TObject);
var
  i: Integer;
begin
  i := RadioGroup5.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  RadioGroup1.ItemIndex := 3;
  TrackBar1.Position := PPLib[3].pp[i].C11;
  TrackBar2.Position := PPLib[3].pp[i].C12;
  TrackBar3.Position := PPLib[3].pp[i].C13;
  TrackBar4.Position := PPLib[3].pp[i].C21;
  TrackBar5.Position := PPLib[3].pp[i].C22;
  TrackBar6.Position := PPLib[3].pp[i].C23;
  TrackBar7.Position := PPLib[3].pp[i].C31;
  TrackBar8.Position := PPLib[3].pp[i].C32;
  TrackBar9.Position := PPLib[3].pp[i].C33;
end;

procedure TPalForm.Button5Click(Sender: TObject);
var
  fs1: TStream;
  i,j,k: Integer;
begin
  if WpalDialog.Execute then
  begin
    fs1 := TFileStream.Create(WpalDialog.GetFileName, fmOpenRead);
    try
      fs1.Read(i, 4);
      if i<>$6C617077 then
        raise Exception.Create('ɲЧĵɫļŶ');

      for i:=Low(PPLib) to High(PPLib) do
      begin
        PPLib[i].pp := nil;
      end;
      PPLib := nil;

      i := GetNumberFromStream(fs1);
      SetLength(PPLib, i);
      i := GetNumberFromStream(fs1);
      for j:=Low(PPLib) to High(PPLib) do
      begin
        PPLib[j].Start := i;
        i := GetNumberFromStream(fs1);
        PPLib[j].Finish := i-1;
      end;
      for j:=Low(PPLib) to High(PPLib) do
      begin
        i := GetNumberFromStream(fs1);
        SetLength(PPLib[j].pp, i);
        for k:=Low(PPLib[j].pp) to High(PPLib[j].pp) do
        begin
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C11 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C12 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C13 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C21 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C22 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C23 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C31 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C32 := i;
          i := GetNumberFromStream(fs1);
          PPLib[j].pp[k].C33 := i;
        end;
      end;

    // 1-4ŷֶѡť
    RadioGroup2.Items.Clear;
    RadioGroup3.Items.Clear;
    RadioGroup4.Items.Clear;
    RadioGroup5.Items.Clear;

    for i:=Low(PPLib) to High(PPLib) do
    begin
      for j:=Low(PPLib[i].pp) to High(PPLib[i].pp) do
      begin
        case i of
        0: Self.RadioGroup2.Items.Add('['+IntToStr(j)+']   '+IntToStr(PPLib[i].Start)+'~'+IntToStr(PPLib[i].Finish));
        1: Self.RadioGroup3.Items.Add('['+IntToStr(j)+']   '+IntToStr(PPLib[i].Start)+'~'+IntToStr(PPLib[i].Finish));
        2: Self.RadioGroup4.Items.Add('['+IntToStr(j)+']   '+IntToStr(PPLib[i].Start)+'~'+IntToStr(PPLib[i].Finish));
        3: Self.RadioGroup5.Items.Add('['+IntToStr(j)+']   '+IntToStr(PPLib[i].Start)+'~'+IntToStr(PPLib[i].Finish));
        end;
      end;
    end;

    // ֶб
    tmpPal := nil;
    RadioGroup1.Items.Clear;
    SetLength(tmpPal, High(PPLib)+1);
    for i:=Low(tmpPal) to High(tmpPal) do
    begin
      tmpPal[i].Start := PPLib[i].Start;
      tmpPal[i].Finish := PPLib[i].Finish;
      tmpPal[i].pp.C11 := PPLib[i].pp[0].C11;
      tmpPal[i].pp.C12 := PPLib[i].pp[0].C12;
      tmpPal[i].pp.C13 := PPLib[i].pp[0].C13;
      tmpPal[i].pp.C21 := PPLib[i].pp[0].C21;
      tmpPal[i].pp.C22 := PPLib[i].pp[0].C22;
      tmpPal[i].pp.C23 := PPLib[i].pp[0].C23;
      tmpPal[i].pp.C31 := PPLib[i].pp[0].C31;
      tmpPal[i].pp.C32 := PPLib[i].pp[0].C32;
      tmpPal[i].pp.C33 := PPLib[i].pp[0].C33;
      RadioGroup1.Items.Add(IntToStr(tmpPal[i].Start)+'~'+IntToStr(tmpPal[i].Finish));
    end;
    if RadioGroup2.Items.Count > 0 then
    begin
      RadioGroup2.ItemIndex := 0;
    end;
    if RadioGroup3.Items.Count > 0 then
    begin
      RadioGroup3.ItemIndex := 0;
    end;
    if RadioGroup4.Items.Count > 0 then
    begin
      RadioGroup4.ItemIndex := 0;
    end;
    if RadioGroup5.Items.Count > 0 then
    begin
      RadioGroup5.ItemIndex := 0;
    end;

    Caption := 'ɫ - ' + WpalDialog.GetFileName;
    finally
      fs1.Free;
    end;
  end;
end;

procedure TPalForm.FormCreate(Sender: TObject);
begin
  // ĬϷֶϢ
  SetLength(tmpPal, 1);
  tmpPal[0].Start := 0;
  tmpPal[0].Finish := 255;
  tmpPal[0].pp.C11 := 256;
  tmpPal[0].pp.C12 := 0;
  tmpPal[0].pp.C13 := 0;
  tmpPal[0].pp.C21 := 0;
  tmpPal[0].pp.C22 := 256;
  tmpPal[0].pp.C23 := 0;
  tmpPal[0].pp.C31 := 0;
  tmpPal[0].pp.C32 := 0;
  tmpPal[0].pp.C33 := 256;

  SetLength(PPLib, 1);
  SetLength(PPLib[0].pp, 1);
  PPLib[0].Start := 0;
  PPLib[0].Finish := 255;
  PPLib[0].pp[0].C11 := 256;
  PPLib[0].pp[0].C12 := 0;
  PPLib[0].pp[0].C13 := 0;
  PPLib[0].pp[0].C21 := 0;
  PPLib[0].pp[0].C22 := 256;
  PPLib[0].pp[0].C23 := 0;
  PPLib[0].pp[0].C31 := 0;
  PPLib[0].pp[0].C32 := 0;
  PPLib[0].pp[0].C33 := 256;

  // update ui
  RadioGroup1.Items.Clear;
  RadioGroup1.Items.Add('0~255');
  RadioGroup1.ItemIndex := 0;
  RadioGroup2.Items.Clear;
  RadioGroup2.Items.Add('[0]   0~255');
  RadioGroup2.ItemIndex := 0;
  RadioGroup3.Items.Clear;
  RadioGroup4.Items.Clear;
  RadioGroup5.Items.Clear;
  Caption := 'ɫ - Ĭ';
end;

procedure TPalForm.ChangePalette(Start, Finish: Integer; ArgS: TPalArg);
var
  i: Integer;
  Color: Word;
  R,G,B: Cardinal;
  R2,G2,B2: Cardinal;
begin
  // ɫֻ0~255
  if (Start < 0) or (Finish > 255) then
  begin
    Exit;
  end;
  for i:=Start to Finish do
  begin
    Color := OriginalPal[i];
    R := (Color and $F800) shr 11;
    G := (Color and $07E0) shr 5;
    B := (Color and $001F);
    R2 := (R * ArgS.C11) + (G * ArgS.C12) + (B * ArgS.C13);
    G2 := (R * ArgS.C21) + (G * ArgS.C22) + (B * ArgS.C23);
    B2 := (R * ArgS.C31) + (G * ArgS.C32) + (B * ArgS.C33);
    R2 := R2 shr 8;
    G2 := G2 shr 8;
    B2 := B2 shr 8;
    if R2>$1F then
    begin
      R2 := $1F;
    end;
    if G2>$3F then
    begin
      G2 := $3F;
    end;
    if B2>$1F then
    begin
      B2 := $1F;
    end;
    CurrentPal[i] := (R2 shl 11) + (G2 shl 5) + B2;
  end;
  WasSeeGlobal.SetCurrentPal(CurrentPal);
end;

procedure TPalForm.FormShow(Sender: TObject);
begin
  // ȡʱҪԭɫ壬ĬTrue;
  IsBack := True;
  WasSeeGlobal.GetCurrentPal(oldpal);
  WasSeeGlobal.GetCurrentPal(CurrentPal);
  WasSeeGlobal.GetOriginalPal(OriginalPal);
end;

procedure TPalForm.TrackBar1Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar1.Position;
  Edit1.Text := IntToStr(j);
  tmpPal[i].pp.C11 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;
end;

procedure TPalForm.TrackBar2Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar2.Position;
  Edit2.Text := IntToStr(j);
  tmpPal[i].pp.C12 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;
end;

procedure TPalForm.TrackBar3Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar3.Position;
  Edit3.Text := IntToStr(j);
  tmpPal[i].pp.C13 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;

end;

procedure TPalForm.TrackBar4Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar4.Position;
  Edit4.Text := IntToStr(j);
  tmpPal[i].pp.C21 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;

end;

procedure TPalForm.TrackBar5Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar5.Position;
  Edit5.Text := IntToStr(j);
  tmpPal[i].pp.C22 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;

end;

procedure TPalForm.TrackBar6Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar6.Position;
  Edit6.Text := IntToStr(j);
  tmpPal[i].pp.C23 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;
end;

procedure TPalForm.TrackBar7Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar7.Position;
  Edit7.Text := IntToStr(j);
  tmpPal[i].pp.C31 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;

end;

procedure TPalForm.TrackBar8Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar8.Position;
  Edit8.Text := IntToStr(j);
  tmpPal[i].pp.C32 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;
end;

procedure TPalForm.TrackBar9Change(Sender: TObject);
var
  i,j: Integer;
begin
  i := RadioGroup1.ItemIndex;
  if i<0 then
  begin
    exit;
  end;
  j := TrackBar9.Position;
  Edit9.Text := IntToStr(j);
  tmpPal[i].pp.C33 := j;
  ChangePalette(tmpPal[i].Start, tmpPal[i].Finish, tmpPal[i].pp);
  WasSeeGlobal.UpdateBgBmp;
end;

procedure TPalForm.Button1Click(Sender: TObject);
begin
  IsBack := False;
  Close;
end;

procedure TPalForm.Button3Click(Sender: TObject);
var
  i: Integer;
begin
  for i:=0 to 255 do
    oldpal[i] := CurrentPal[i];
end;

procedure TPalForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IsBack then
  begin
    WasSeeGlobal.SetCurrentPal(oldpal);
  end;
end;

end.
